﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace editor_text
{
    public partial class Form1 : Form
    {
        string fisier_curent;
        bool salvat;

        public Form1()
        {
            InitializeComponent();
        }

        private void salvareToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.SaveFile(fisier_curent);
            salvat = true;
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            fisier_curent = "nou.rtf";
            salvat = true;
            //richTextBox1.Top = toolStrip1.Top + toolStrip1.Height;
        }

        private void nouToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            fisier_curent = "nou.rtf";
            this.Text = "Text editor v1.0 - " + fisier_curent;
            salvat = true;
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if(!salvat)
            {
                DialogResult m = MessageBox.Show(
                    "Fisierul nu este salvat. Doriti sa il salvati?",
                    "Iesire", MessageBoxButtons.YesNoCancel);
                if(m==DialogResult.Yes)
                {
                    richTextBox1.SaveFile(fisier_curent);
                    Application.Exit();
                }
                else if(m==DialogResult.No) Application.Exit();
            }           
        }

        private void deschideToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = Application.StartupPath;
            openFileDialog1.FileName = "";
            //openFileDialog1.Filter = "Fisiere RTF|*.rtf|Fisiere TXT|*.txt";
            openFileDialog1.Filter = "Fisiere RTF|*.rtf";
            if(openFileDialog1.ShowDialog()==DialogResult.OK)
            {
                fisier_curent=openFileDialog1.FileName;
                richTextBox1.LoadFile(fisier_curent);
                this.Text = "Text editor v1.0 - " + nume_scurt(fisier_curent);
                salvat = true;
            }
        }

        private void salvareCaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog1.InitialDirectory = Application.StartupPath;
            saveFileDialog1.FileName = "";
            saveFileDialog1.Filter = "Fisiere RTF|*.rtf";
            if(saveFileDialog1.ShowDialog()==DialogResult.OK)
            {
                fisier_curent = saveFileDialog1.FileName;
                richTextBox1.SaveFile(fisier_curent);
                this.Text = "Text editor v1.0 - " + nume_scurt(fisier_curent);
                salvat = true;
            }
        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {
            salvat = false;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (!salvat)
            {
                DialogResult m = MessageBox.Show(
                    "Fisierul nu este salvat. Doriti sa il salvati?",
                    "Iesire", MessageBoxButtons.YesNoCancel);
                if (m == DialogResult.Yes)
                    richTextBox1.SaveFile(fisier_curent);
                else if (m == DialogResult.Cancel)  e.Cancel=true;
            }
        }

        private void copiereToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.Copy();
        }

        private void taiereToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.Cut();
        }

        private void lipireToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.Paste();
        }

        private void selectareTotalaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectAll();
        }

        string nume_scurt(string s)
        {
            int p = 0;
            for(int i=s.Length-1;i>=0;i--)
                if(s[i]=='\\')
                {
                    p = i;
                    break;
                }
            return s.Substring(p+1);
        }

        private void culoareToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if(colorDialog1.ShowDialog()==DialogResult.OK)
            {
                richTextBox1.SelectionColor = colorDialog1.Color;
            }
        }

        private void fontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fontDialog1.Font = richTextBox1.SelectionFont;
            if(fontDialog1.ShowDialog()==DialogResult.OK)
                richTextBox1.SelectionFont = fontDialog1.Font;
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            //richTextBox1.Height= this.Height-200;
        }

        private void newToolStripButton_Click(object sender, EventArgs e)
        {
            nouToolStripMenuItem_Click(sender, e);
        }

        private void openToolStripButton_Click(object sender, EventArgs e)
        {
            deschideToolStripMenuItem_Click(sender, e);
        }

        private void saveToolStripButton_Click(object sender, EventArgs e)
        {
            salvareToolStripMenuItem_Click(sender, e);
        }

        private void cutToolStripButton_Click(object sender, EventArgs e)
        {
            taiereToolStripMenuItem_Click(sender, e);
        }

        private void copyToolStripButton_Click(object sender, EventArgs e)
        {
            copiereToolStripMenuItem_Click(sender, e);
        }

        private void pasteToolStripButton_Click(object sender, EventArgs e)
        {
            lipireToolStripMenuItem_Click(sender, e);
        }

        private void centruToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Center;
        }

        private void stangaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Left;
        }

        private void dreaptaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Right;
        }
    }
}
